<?xml version="1.0" encoding="UTF-8"?>

<?import javafx.scene.text.*?>
<?import javafx.scene.control.*?>
<?import javafx.geometry.*?>
<?import java.lang.*?>
<?import javafx.scene.layout.*?>

<BorderPane maxHeight="8000" maxWidth="8000" minHeight="-Infinity" minWidth="-Infinity" prefHeight="640.0" prefWidth="880.0" xmlns="http://javafx.com/javafx/8" xmlns:fx="http://javafx.com/fxml/1">
   <right>
      <VBox fx:id="rightBox" alignment="CENTER" minWidth="500.0" BorderPane.alignment="CENTER">
         <children>
            <GridPane fx:id="gridPane" alignment="CENTER" hgap="10.0" minHeight="300.0" minWidth="400.0" vgap="5.0" VBox.vgrow="NEVER">
              <columnConstraints>
                <ColumnConstraints hgrow="SOMETIMES" maxWidth="95.0" minWidth="10.0" prefWidth="48.0" />
                <ColumnConstraints hgrow="SOMETIMES" maxWidth="230.0" minWidth="10.0" prefWidth="154.0" />
                  <ColumnConstraints hgrow="SOMETIMES" maxWidth="192.0" minWidth="10.0" prefWidth="178.0" />
              </columnConstraints>
              <rowConstraints>
                  <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                  <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                  <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
                  <RowConstraints minHeight="10.0" prefHeight="30.0" vgrow="SOMETIMES" />
              </rowConstraints>
               <children>
                  <Text fx:id="lblMustInclude" strokeType="OUTSIDE" strokeWidth="0.0" text="Must include words:" GridPane.columnIndex="1" GridPane.rowIndex="1" />
                  <Text fx:id="lblMustExclude" strokeType="OUTSIDE" strokeWidth="0.0" text="Must exclude words:" GridPane.columnIndex="1" GridPane.rowIndex="2" />
                  <Text fx:id="lblMinLetters" strokeType="OUTSIDE" strokeWidth="0.0" text="Min/max letters per word:" GridPane.columnIndex="1" GridPane.rowIndex="3" />
                  <Text fx:id="lblMaxWords" strokeType="OUTSIDE" strokeWidth="0.0" text="Max words per anagram:" GridPane.columnIndex="1" GridPane.rowIndex="5" />
                  <Text fx:id="lblMaxAnagrams" strokeType="OUTSIDE" strokeWidth="0.0" text="Approx. max anagrams:" GridPane.columnIndex="1" />
                  <TextField fx:id="txtIncludeWords" maxWidth="200.0" onKeyReleased="#onEnterPressed" promptText="Enter required words" GridPane.columnIndex="2" GridPane.rowIndex="1">
                     <tooltip>
                        <Tooltip text="Words that you want to be included in every anagram." wrapText="true" />
                     </tooltip></TextField>
                  <TextField fx:id="txtExcludeWords" maxWidth="200.0" onKeyReleased="#onEnterPressed" promptText="Enter unwanted words" GridPane.columnIndex="2" GridPane.rowIndex="2">
                     <tooltip>
                        <Tooltip text="Words that you don't want to be in any of the anagrams." wrapText="true" />
                     </tooltip></TextField>
                  <TextField fx:id="txtMaxAnagrams" maxWidth="89.0" onKeyReleased="#onEnterPressed" prefHeight="25.0" prefWidth="89.0" promptText="?" text="5000" GridPane.columnIndex="2">
                     <tooltip>
                        <Tooltip text="Maximum number of anagrams to generate." wrapText="true" />
                     </tooltip></TextField>
                  <Slider fx:id="sliderMaxWords" blockIncrement="1.0" majorTickUnit="1.0" max="15.0" min="1.0" minorTickCount="0" showTickLabels="true" showTickMarks="true" snapToTicks="true" value="10.0" GridPane.columnIndex="1" GridPane.columnSpan="2" GridPane.rowIndex="6">
                     <tooltip>
                        <Tooltip text="Adjust the maximum number of words in each anagram." wrapText="true" />
                     </tooltip></Slider>
               </children>
               <VBox.margin>
                  <Insets />
               </VBox.margin>
               <padding>
                  <Insets bottom="10.0" left="10.0" right="10.0" top="10.0" />
               </padding>
            </GridPane>
            <HBox alignment="CENTER" prefHeight="77.0" prefWidth="420.0" spacing="10.0">
               <children>
                  <ProgressIndicator fx:id="indicator" maxHeight="30.0" maxWidth="30.0" minHeight="30.0" minWidth="30.0" prefHeight="30.0" prefWidth="30.0" visible="false" />
                  <Button fx:id="submitButton" minHeight="60.0" minWidth="140.0" mnemonicParsing="false" onAction="#onSubmitPressed" prefHeight="60.0" prefWidth="140.0" styleClass="rich-blue" text="Find Anagrams">
                     <tooltip>
                        <Tooltip text="Find Anagrams" />
                     </tooltip></Button>
                  <Button fx:id="candidatesButton" minHeight="60.0" minWidth="140.0" mnemonicParsing="false" onAction="#onShowCandidatesPressed" prefHeight="60.0" prefWidth="140.0" text="Show&#10;Candidates" textAlignment="CENTER">
                     <tooltip>
                        <Tooltip text="Don't generate anagrams, only show the individual words that can be formed from the input string." wrapText="true" />
                     </tooltip>
                  </Button>
                  <Button fx:id="clearButton" minHeight="60.0" minWidth="60.0" mnemonicParsing="false" onAction="#onClearPressed" prefHeight="60.0" prefWidth="60.0" text="Clear">
                     <tooltip>
                        <Tooltip text="Clear" wrapText="true" />
                     </tooltip></Button>
               </children>
            </HBox>
            <Label fx:id="statusLabel" minWidth="100.0" text=" " VBox.vgrow="ALWAYS" />
         </children>
         <padding>
            <Insets bottom="10.0" left="10.0" right="10.0" top="10.0" />
         </padding>
      </VBox>
   </right>
   <center>
      <VBox fx:id="leftVBox" alignment="TOP_CENTER" spacing="10.0" BorderPane.alignment="CENTER">
         <children>
            <TextField fx:id="inputTextField" onKeyReleased="#onEnterPressed" prefHeight="25.0" prefWidth="92.0" promptText="Type the string for which you want to find anagrams here." text="This is a test">
               <tooltip>
                  <Tooltip text="Type your input text here." />
               </tooltip></TextField>
            <TextArea fx:id="outputTextArea" editable="false" prefWidth="200.0" wrapText="true" VBox.vgrow="ALWAYS">
               <tooltip>
                  <Tooltip text="Generated anagrams are shown here." />
               </tooltip></TextArea>
         </children>
      </VBox>
   </center>
   <padding>
      <Insets bottom="10.0" left="10.0" right="10.0" top="10.0" />
   </padding>
</BorderPane>
